(defun elefunt-fix-formats ()
  (interactive)
  (goto-char (point-min))
  (query-replace "7.2f" "7.2Lf" nil nil nil)
  (goto-char (point-min))
  (query-replace "15.4e" "15.4Le" nil nil nil)
  )

(defun fix-elefunt-dp-functions ()
  (interactive)
  (goto-char (point-min))
  (query-replace "float" "dp_t" 1)
  (goto-char (point-min))
  (query-replace "acos" "ACOS" 1)
  (goto-char (point-min))
  (query-replace "log" "ALOG" 1)
  (goto-char (point-min))
  (query-replace "log10" "ALOG10" 1)
  (goto-char (point-min))
  (query-replace "asin" "ASIN" 1)
  (goto-char (point-min))
  (query-replace "atan" "ATAN" 1)
  (query-replace "atan2" "ATAN2" 1)
  (goto-char (point-min))
  (query-replace "cos" "COS" 1)
  (query-replace "cosh" "COSH" 1)
  (goto-char (point-min))
  (query-replace "cotan" "COTAN" 1)
  (query-replace "exp" "EXP" 1)
  (goto-char (point-min))
  (query-replace "floor" "FLOOR" 1)
  (query-replace "ipow" "IPOW" 1)
  (goto-char (point-min))
  (query-replace "ldexp" "LDEXP" 1)
  (query-replace "log" "LOG" 1)
  (goto-char (point-min))
  (query-replace "log10" "LOG10" 1)
  (query-replace "modf" "MODF" 1)
  (goto-char (point-min))
  (query-replace "pow" "POW" 1)
  (query-replace "ran" "RAN" 1)
  (goto-char (point-min))
  (query-replace "randl" "RANDL" 1)
  (query-replace "sin" "SIN" 1)
  (goto-char (point-min))
  (query-replace "sinh" "SINH" 1)
  (query-replace "sqrt" "SQRT" 1)
  (goto-char (point-min))
  (query-replace "store" "STORE" 1)
  (query-replace "tan" "TAN" 1)
  (goto-char (point-min))
  (query-replace "tanh" "TANH" 1))

(defun fix-elefunt-qp-casts ()
  (interactive)
  (goto-char (point-min))
  (query-replace-regexp "(qp_t) *\\([A-Za-z_0-9]+\\)" "TO_FP_T(\\1)"))

(defun fix-elefunt-dp-casts ()
  (interactive)
  (goto-char (point-min))
  (query-replace-regexp "(dp_t) *\\([A-Za-z_0-9]+\\)" "TO_FP_T(\\1)"))

(re-search-forward "(qp_t) *\\([A-Za-z_0-9]+\\)")
(re-search-forward "(dp_t) *\\([A-Za-z_0-9]+\\)")

(defun elefunt-fix-formats ()
  (interactive)
  (goto-char (point-min))
  (query-replace "7.2f" "7.2Lf" nil nil nil)
  (goto-char (point-min))
  (query-replace "15.4e" "15.4Le" nil nil nil)
  )

(defun java-convert-c-formats()
  (interactive)

  (goto-char (point-min))
  (query-replace-regexp "(void)printf" "System.out.print")

  (goto-char (point-min))
  (query-replace-regexp "printf" "System.out.print")

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)d" "\" + fmt.I(,\\1) + \"")

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)e" "\" + fmt.E(,\\1,6) + \"") ; missing e precision defaults to 6 in Standard C!

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)f" "\" + fmt.F(,\\1,6) + \"") ; missing f precision defaults to 6 in Standard C!

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)g" "\" + fmt.G(,\\1,1) + \"") ; missing g precision defaults to 1 in Standard C!

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)[.]\\([0-9]+\\)e" "\" + fmt.E(,\\1,\\2) + \"")

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)[.]\\([0-9]+\\)f" "\" + fmt.F(,\\1,\\2) + \"")

  (goto-char (point-min))
  (query-replace-regexp "%\\([0-9]+\\)[.]\\([0-9]+\\)g" "\" + fmt.G(,\\1,\\2) + \"")

  (goto-char (point-min))
  (query-replace "\"\" + " "")

  (goto-char (point-min))
  (query-replace-regexp "^[ \t]*errno = 0;\n" "")

  (goto-char (point-min))
  (query-replace-regexp "^[ \t]*fflush(stdout);\n" "")
  )

(defun java-convert-machar-names()
  (interactive)

  (goto-char (point-min))
  (query-replace-regexp "\\(ibeta\\|it\\|irnd\\|ngrd\\|machep\\|negep\\|iexp\\|minexp\\|maxexp\\|eps\\|epsneg\\|xmin\\|xmax\\)" 
			"machar.\\1" t))
